---
title: Introduction to the File and Directory Entries API
slug: Web/API/File_and_Directory_Entries_API/Introduction
tags:
  - API
  - Beginner
  - File
  - File System API
  - File and Directory Entries API
  - Guide
  - Introduction
  - Non-standard
---
<div>{{DefaultAPISidebar("File System API")}}{{Non-standard_header}}</div>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a> simulates a local file system that web apps can navigate around. You can develop apps that can read, write, and create files and directories in a sandboxed, virtual file system.</span></p>

<p>The File and Directory Entries API interacts with other related APIs. It was built on the File Writer API, which, in turn, was built on File API. Each of the APIs adds different functionality. These APIs are a giant evolutionary leap for web apps, which can now cache and process large amounts of data. </p>

<h2 id="About_this_document">About this document</h2>

<p>This introduction discusses essential concepts and terminology in the File and Directory Entries API. It gives you the big picture and orients you to <a href="#concepts">key concepts</a>. It also describes <a href="#restrictions">restrictions</a> that raise security errors if you ignore them. To learn more about terminology used in this API, see the <a href="#definitions">Definitions</a> section. </p>

<p>For the reference documentation on the File and Directory Entries API, see the <a href="/en/DOM/File_API/File_System_API/FileSystem" title="en/DOM/File_API/File_System_API/FileSystem">reference</a> landing page and its subpages.</p>

<p>The specification is still being defined and is subject to change.</p>

<h2 id="Overview">Overview</h2>

<p>The File and Directory Entries API includes both <a href="/en/DOM/File_API/File_System_API#Asynchronous_APIs" title="en/DOM/File_API/File_System_API#Asynchronous_APIs">asynchronous</a> and <a href="/en/DOM/File_API/File_System_API#Synchronous_APIs" title="en/DOM/File_API/File_System_API#Synchronous_APIs">synchronous</a> versions of the interfaces. The asynchronous API can be used in cases where you don't want an outstanding operation to block the UI. The synchronous API, on the other hand, allows for simpler programming model, but it must be used with <a href="/En/Using_web_workers">WebWorkers</a>. </p>

<h3 id="Usefulness_of_the_API">Usefulness of the API</h3>

<p>The File and Directory Entries API is an important API for the following reasons:</p>

<ul>
 <li>It lets apps have offline and storage features that involve large binary blobs.</li>
 <li>It can improve performance by letting an app pre-fetch assets in the background and cache locally.</li>
 <li>It lets users of your web app directly edit a binary file that's in their local file directory.</li>
 <li>It provides a storage API that is already familiar to your users, who are used to working with file systems. </li>
</ul>

<p>For examples of features you can create with this app, see the <a href="/#samples" title="#samples">Sample use cases</a> section.  </p>

<h3 id="The_File_and_Directory_Entries_API_and_other_storage_APIs">The File and Directory Entries API and other storage APIs</h3>

<p>The File and Directory Entries API is an alternative to other storage APIs like <a href="/en/IndexedDB/Basic_Concepts_Behind_IndexedDB" title="en/IndexedDB/Basic_Concepts_Behind_IndexedDB">IndexedDB</a>, WebSQL (which has been deprecated since November18, 2010), and AppCache. The API is a better choice for apps that deal with blobs for the following reasons:</p>

<ul>
 <li>The File and Directory Entries API offers client-side storage for use cases that are not addressed by databases. If you want to have large mutable chunks of data, the File and Directory Entries API is a much more efficient storage solution than a database.</li>
 <li>While Firefox supports blob storage for IndexedDB, Chrome currently does not (Chrome is still implementing support for blob storage in IndexedDB). If you are targeting Chrome for your app and you want to store blobs, the File and Directory Entries API and App Cache are your only choices. However, AppCache storage isn't locally mutable, and doesn't allow for fine-grained client-side management.</li>
 <li>In Chrome, you can use the File and Directory Entries API with the <a class="external" href="http://code.google.com/chrome/whitepapers/storage.html">Quota Management API</a>, which lets you ask for more storage and manage your storage quota. </li>
</ul>

<h3 id="sample">Sample use cases</h3>

<p>The following are just a few examples of how you can use the File and Directory Entries API:</p>

<ul>
 <li>Apps with persistent uploader
  <ul>
   <li>When a file or directory is selected for upload, you can copy the file into a local sandbox and upload a chunk at a time.</li>
   <li>The app can restart uploads after an interruption, such as the browser being closed or crashing, connectivity getting interrupted, or the computer getting shut down.</li>
  </ul>
 </li>
 <li>Video game or other apps with lots of media assets
  <ul>
   <li>The app downloads one or several large tarballs and expands them locally into a directory structure.</li>
   <li>The app pre-fetches assets in the background, so the user can go to the next task or game level without waiting for a download.</li>
  </ul>
 </li>
 <li>Audio or photo editor with offline access or local cache (great for performance and speed)
  <ul>
   <li>The app can write to files in place (for example, overwriting just the ID3/EXIF tags and not the entire file).</li>
  </ul>
 </li>
 <li>Offline video viewer
  <ul>
   <li>The app can download large files (&gt;1GB) for later viewing.</li>
   <li>The app can access partially downloaded files (so that you can watch the first chapter of your DVD, even if the app is still downloading the rest of the content or if the app didn't complete the download because you had to run to catch a train).</li>
  </ul>
 </li>
 <li>Offline web mail client
  <ul>
   <li>The client downloads attachments and stores them locally.</li>
   <li>The client caches attachments for later upload.</li>
  </ul>
 </li>
</ul>

<h2 id="concepts">Big concepts</h2>

<p>Before you start using the File and Directory Entries API, you need to understand a few concepts:</p>

<ul>
 <li><a href="#virtual">The File and Directory Entries API is a virtual representation of a file system</a></li>
 <li><a href="#storage">The File and Directory Entries API can use different storage types</a></li>
 <li><a href="#quota">Browsers impose storage quota</a></li>
 <li><a href="#versions">The File and Directory Entries API has asynchronous and synchronous versions</a></li>
 <li><a href="#errorcallbacks">When using the asynchronous API, always use the error callbacks</a></li>
 <li><a href="#interfaces">The File and Directory Entries API interacts with other APIs</a></li>
 <li><a href="#case">The File and Directory Entries API is case-sensitive</a></li>
</ul>

<h3 id="virtual">The File and Directory Entries API is a virtual representation of a file system</h3>

<p>The API doesn't give you access to the local file system, nor is the sandbox really a section of the file system. Instead, it is a virtualized file system that looks like a full-fledged file system to the web app. It does not necessarily have a relationship to the local file system outside the browser. </p>

<p>What this means is that a web app and a desktop app cannot share the same file at the same time. The API does not let your web app reach outside the browser to files that desktop apps can also work on. You can, however, export a file from a web app to a desktop app. For example, you can use the File API, create a blob, redirect an iframe to the blob, and invoke the download manager.</p>

<h3 id="storage">The File and Directory Entries API can use different storage types</h3>

<p>An application can request temporary or persistent storage. Temporary storage is easier to get, because the browser just gives it to you, but it is limited and can be deleted by the browser when it runs out of space. Persistent storage, on the other hand, might offer you larger space that can only be deleted by the user, but it requires the user to grant you permission.</p>

<p>Use temporary storage for caching and persistent storage for data that you want your app to keep—such as user-generated or unique data.</p>

<h3 id="quota">Browsers impose storage quotas</h3>

<p>To prevent a web app from using up the entire disk, browsers might impose a quota for each app and allocate storage among web apps.</p>

<p>How storage space is granted or allocated and how you can manage storage are idiosyncratic to the browser, so you need to check the respective documentation of the browser. Google Chrome, for example, allows temporary storage beyond the 5 MB required in the specifications and supports the Quota Management API. To learn more about the Chrome-specific implementation, see <a class="external" href="http://code.google.com/chrome/whitepapers/storage.html">Managing HTML5 Offline Storage</a>.</p>

<h3 id="version">The File and Directory Entries API has asynchronous and synchronous versions</h3>

<p>The File and Directory Entries API comes with asynchronous and synchronous versions. Both versions of the API offer the same capabilities and features. In fact, they are almost alike, except for a few differences.</p>

<ul>
 <li><strong>WebWorkers.</strong> The asynchronous API can be used in either the document or <a href="/En/Using_web_workers" rel="internal">WebWorkers</a> context, while the synchronous API is for use with WebWorkers only. </li>
 <li><strong>Callbacks</strong>. The asynchronous API doesn't give you data by returning values; instead, you have to pass a callback function. You send requests for operations to happen, and get notified by callbacks. In contrast, the synchronous API does not use callbacks because the API methods return values.</li>
 <li><strong>Global methods of the asynchronous and synchronous APIs</strong>. The asynchronous API has the following global methods: <code>requestFileSystem()</code> and <code>resolveLocalFileSystemURL()</code>. These methods are members of both the window object and the worker global scope. The synchronous API, on the other hand, uses the following methods:  <code>requestFileSystemSync()</code> and  <code>resolveLocalFileSystemSyncURL()</code>. These synchronous methods are members of the worker's global scope only, not the window object.</li>
</ul>

<p>The synchronous API can be simpler for some tasks. Its direct, in-order programming model can make code easier to read. The drawback of synchronous API has to do with its interactions with Web Workers, which has some limitations.</p>

<h3 id="errorcallbacks">When using the asynchronous API, always use the error callbacks</h3>

<p>When using the asynchronous API, always use the error callbacks. Although the error callbacks for the methods are optional parameters, they are not optional for your sanity. You want to know why your calls failed. At minimum, handle the errors to provide error messages, so you'll have an idea of what's going on.</p>

<h3 id="interfaces">The File and Directory Entries API interacts with other APIs</h3>

<p>The File and Directory Entries API is designed to be used with other APIs and elements on the web platform. For example, you are likely to use one of the following:</p>

<ul>
 <li>XMLHttpRequest (such as the <code>send()</code> method for file and blob objects)</li>
 <li>Drag and Drop API</li>
 <li>Web Workers (for the synchronous version of the File and Directory Entries API)</li>
 <li>The <code>input</code> element (to programmatically obtain a list of files from the element)</li>
</ul>

<h3 id="case">The File and Directory Entries API is case sensitive</h3>

<div>The filesystem API is case-sensitive, and case-preserving. </div>

<h2 id="restrictions">Restrictions</h2>

<p>For security reasons, browsers impose restrictions on file access. If you ignore them, you will get security errors.</p>

<ul>
 <li><a href="#origin">The File and Directory Entries API adheres to the same-origin policy</a></li>
 <li><a href="#execute">The File and Directory Entries API does not let you create and rename executable files</a></li>
 <li><a href="#sandbox">The file system is sandboxed</a></li>
 <li><a href="#file">You cannot run your app from file://</a></li>
</ul>

<h3 id="origin">The File and Directory Entries API adheres to the same-origin policy</h3>

<p>An origin is the domain, application layer protocol, and port of a URL of the document where the script is being executed. Each origin has its own associated set of file systems.</p>

<p>The security boundary imposed on file system prevents applications from accessing data with a different origin. This protects private data by preventing access and deletion. For example, while an app or a page in <a href="http://www.example.com/app/" rel="external" title="http://www.example.com/app/">http://www.example.com/app/</a> can access files from <a href="http://www.example.com/dir/" rel="external" title="http://www.example.com/dir/">http://www.example.com/dir/</a>, because they have the same origin, it cannot retrieve files from <a href="http://www.example.com:8080/dir/" rel="external" title="http://www.example.com:8080/dir/">http://www.example.com:8080/dir/</a> (different port) or <a href="https://www.example.com/dir/" rel="external" title="https://www.example.com/dir/">https://www.example.com/dir/</a> (different protocol).</p>

<h3 id="execute">The File and Directory Entries API does not let you create and rename executable files</h3>

<p>To prevent malicious apps from running hostile executables, you cannot create executable files within the sandbox of the File and Directory Entries API. </p>

<h3 id="sandbox">The file system is sandboxed</h3>

<p>Because the file system is sandboxed, a web app cannot access another app's files. You also cannot read or write files to an arbitrary folder (for example, My Pictures and My Documents) on the user's hard drive.</p>

<h3 id="file">You cannot run your app from file://</h3>

<p>You cannot run your app locally from <code>file://</code>. If you do so, the browser throws errors or your app fails silently. This restriction also applies to many of the file APIs, including BlobBuilder and FileReader.</p>

<p>For testing purposes, you can bypass the restriction on Chrome by starting the browser with the <code>--allow-file-access-from-files</code> flag. Use this flag only for this purpose.</p>

<h2 id="definitions">Definitions</h2>

<p>This section defines and explains terms used in the File and Directory Entries API.</p>

<dl>
 <dt><a name="gloss_blob">blob</a></dt>
 <dd>Stands for binary large object. A blob is a set of binary data that is stored as a single object. It is a general-purpose way to reference binary data in web applications. A blob can be an image or an audio file.</dd>
 <dt><a name="gloss_Blob">Blob</a></dt>
 <dd>Blob—with a capital B—is a data structure that is immutable, which means that binary data referenced by a Blob cannot be modified directly. This makes Blobs act predictably when they are passed to asynchronous APIs.</dd>
 <dt><a name="gloss_persistent_storage">persistent storage</a></dt>
 <dd>Persistent storage is storage that stays in the browser unless the user expunges it or the app deletes it. </dd>
 <dt><a name="gloss_temporary_storage">temporary storage</a></dt>
 <dd>Transient storage is available to any web app. It is automatic and does not need to be requested, but the browser can delete the storage without warning.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('File System API')}}</td>
   <td>{{Spec2('File System API')}}</td>
   <td>Draft of proposed API</td>
  </tr>
 </tbody>
</table>

<p>This API has no official W3C or WHATWG specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="FileSystem"><code>FileSystem</code></h3>

<p>{{Compat("api.FileSystem", 0)}}</p>

<h3 id="FileSystemSync_property"><code>FileSystemSync</code> property</h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.FileSystemSync", 0)}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a class="external" href="http://www.html5rocks.com/en/tutorials/file/filesystem/">Exploring the FileSystem APIs</a> (HTML5 Rocks)</li>
</ul>
